import { OnInit, AfterViewChecked, EventEmitter } from '@angular/core';
import { ColumnInfo, ColumnFormat, ColumnSort } from './column-info';
import { NgForm } from '@angular/forms';
import { ChangedCellArgs } from "./changed-cell-args";
export declare class AtGrid implements OnInit, AfterViewChecked {
    /**Данные*/
    data: Array<Object>;
    /**Колонки*/
    metaData: ColumnInfo[];
    /**Количество строк на странице*/
    quRowOnPage: number;
    /**Статический режим*/
    staticMode: boolean;
    /**Текущая страница*/
    currentPage: number;
    /**Текущая страница*/
    imageSize: number;
    /**Для установки стиля ячейки (row: Object, column: ColumnInfo) => {({'background-color': 'red'})}*/
    callbackSetCellStyle: Function;
    /**Имя грида для хранения лайаутов*/
    name: string;
    /**Выделене какой-то позиции*/
    onSelect: EventEmitter<Object>;
    /**Форма*/
    form: NgForm;
    /**Номер строки с наведенной мышкой*/
    rowNumMouseOver: number;
    /**Ячейка под указателем*/
    cellOver: ColumnInfo;
    /**Выделене какой-то позиции*/
    onLoad: EventEmitter<number>;
    /***/
    onChanged: EventEmitter<ChangedCellArgs>;
    /**Энум в компонет*/
    columnFormat: typeof ColumnFormat;
    /**Энум в компонет*/
    columnSort: typeof ColumnSort;
    /**Ширина стрелки сортировки*/
    arrowWidth: number;
    /**Высота стрелки сортировки*/
    arrowHeight: number;
    /**Показать порядок сортировки*/
    showSortOrder: boolean;
    /**Конструктор*/
    constructor();
    /**Инит компонента*/
    ngOnInit(): void;
    /**После загрузки вьюхи*/
    ngAfterViewChecked(): void;
    /**Выделить строку*/
    selectRow(item: Object): void;
    /**Первая страница*/
    firstPage(): void;
    /**Первая страница*/
    lastPage(): void;
    /**Первая страница*/
    nextPage(): void;
    /**Первая страница*/
    prevPage(): void;
    /**Количество страниц*/
    getQuPage(): number;
    /**Номер страницы от 1*/
    getHumanCurrentPage(): number;
    applyFilter(): Array<Object>;
    /**Сравнить две строки*/
    compareColumn(a: object, b: object, columnInfo: ColumnInfo): number;
    /**Получить строки для страницы*/
    getRowForPage(): Array<Object>;
    /**Фильтр изменен*/
    filterChanged(filter: any): void;
    /***/
    mouseOver(rowNum: number): void;
    /***/
    mouseOverCell(cellOver: ColumnInfo): void;
    /***/
    getCellId(rowNum: number, colNum: number): string;
    /**Ячейка изменена*/
    changedCell(param: ChangedCellArgs): void;
    /***/
    isAllowEdit(rowNum: number, column: ColumnInfo): boolean;
    /***/
    setDatetime(item: object, column: ColumnInfo, value: any): void;
    /**Получить размер шрифта по умолчанию*/
    getDefaultFontSize(): number;
    /***/
    calcShowSortOrder(): void;
    /**Изменить сортировку колонки*/
    changeSort(columnInfo: ColumnInfo): void;
    /***/
    getOutGridName(): string;
    /***/
    saveLayouts(): void;
    /***/
    restoreLayouts(): void;
}
