import { FilterInfo } from './filter-info';
/**Информация о колонке*/
export declare class ColumnInfo {
    name: string;
    comment: string;
    allowSort: boolean;
    filterInfo: FilterInfo;
    columnFormat: ColumnFormat;
    editable: boolean;
    /**Сортировка текущей колонки*/
    columnSort: ColumnSort;
    /**Порядок сортировок если несклько колонок*/
    columnSortNumber: number;
    /**Конструктор*/
    constructor(name: string, comment: string, allowSort?: boolean, filterInfo?: FilterInfo, columnFormat?: ColumnFormat, editable?: boolean);
}
/**Форматы колонки*/
export declare enum ColumnFormat {
    Date = 0,
    Datetime = 1,
    Number = 2,
    Currency = 3,
    Default = 4,
    Boolean = 5,
    Picture = 6,
    Template = 7,
}
/**Сортировки колонки*/
export declare enum ColumnSort {
    Ask = 0,
    Desc = 1,
    None = 2,
}
